/*
 *  Author: Mike Atkinson
 *
 *  This software has been developed under the copyleft
 *  rules of the GNU General Public License.  Please
 *  consult the GNU General Public License for more
 *  details about use and distribution of this software.
 */
package org.acm.seguin.parser;

import org.acm.seguin.parser.ast.*;
import org.acm.seguin.parser.io.*;


/* Generated By:JJTree&JavaCC: Do not edit this line. JavaParserConstants.java */
public interface JavaParserConstants {

  int EOF = 0;
  int SINGLE_LINE_COMMENT = 13;
  int FORMAL_COMMENT = 14;
  int MULTI_LINE_COMMENT = 15;
  int CATEGORY_COMMENT = 16;
  int ABSTRACT = 18;
  int BOOLEAN = 19;
  int BREAK = 20;
  int BYTE = 21;
  int CASE = 22;
  int CATCH = 23;
  int CHAR = 24;
  int CLASS = 25;
  int CONST = 26;
  int CONTINUE = 27;
  int _DEFAULT = 28;
  int DO = 29;
  int DOUBLE = 30;
  int ELSE = 31;
  int EXTENDS = 32;
  int FALSE = 33;
  int FINAL = 34;
  int FINALLY = 35;
  int FLOAT = 36;
  int FOR = 37;
  int GOTO = 38;
  int IF = 39;
  int IMPLEMENTS = 40;
  int IMPORT = 41;
  int INSTANCEOF = 42;
  int INT = 43;
  int INTERFACE = 44;
  int LONG = 45;
  int NATIVE = 46;
  int NEW = 47;
  int NULL = 48;
  int PACKAGE = 49;
  int PRIVATE = 50;
  int PROTECTED = 51;
  int PUBLIC = 52;
  int RETURN = 53;
  int SHORT = 54;
  int STATIC = 55;
  int STRICTFP = 56;
  int SUPER = 57;
  int SWITCH = 58;
  int SYNCHRONIZED = 59;
  int THIS = 60;
  int THROW = 61;
  int THROWS = 62;
  int TRANSIENT = 63;
  int TRUE = 64;
  int TRY = 65;
  int VOID = 66;
  int VOLATILE = 67;
  int WHILE = 68;
  int INTEGER_LITERAL = 69;
  int DECIMAL_LITERAL = 70;
  int HEX_LITERAL = 71;
  int OCTAL_LITERAL = 72;
  int FLOATING_POINT_LITERAL = 73;
  int EXPONENT = 74;
  int CHARACTER_LITERAL = 75;
  int STRING_LITERAL = 76;
  int IDENTIFIER = 77;
  int LETTER = 78;
  int DIGIT = 79;
  int LPAREN = 80;
  int RPAREN = 81;
  int LBRACE = 82;
  int RBRACE = 83;
  int LBRACKET = 84;
  int RBRACKET = 85;
  int SEMICOLON = 86;
  int COMMA = 87;
  int DOT = 88;
  int VARARG = 89;
  int ASSIGN = 90;
  int GT = 91;
  int LT = 92;
  int BANG = 93;
  int TILDE = 94;
  int HOOK = 95;
  int COLON = 96;
  int EQ = 97;
  int LE = 98;
  int GE = 99;
  int NE = 100;
  int SC_OR = 101;
  int SC_AND = 102;
  int INCR = 103;
  int DECR = 104;
  int PLUS = 105;
  int MINUS = 106;
  int STAR = 107;
  int SLASH = 108;
  int BIT_AND = 109;
  int BIT_OR = 110;
  int XOR = 111;
  int REM = 112;
  int LSHIFT = 113;
  int RSIGNEDSHIFT = 114;
  int RUNSIGNEDSHIFT = 115;
  int PLUSASSIGN = 116;
  int MINUSASSIGN = 117;
  int STARASSIGN = 118;
  int SLASHASSIGN = 119;
  int ANDASSIGN = 120;
  int ORASSIGN = 121;
  int XORASSIGN = 122;
  int REMASSIGN = 123;
  int LSHIFTASSIGN = 124;
  int RSIGNEDSHIFTASSIGN = 125;
  int RUNSIGNEDSHIFTASSIGN = 126;
  int ATTRIBUTE = 127;

  int DEFAULT = 0;
  int IN_ONLY_EOF = 1;
  int IN_SINGLE_LINE_COMMENT = 2;
  int IN_FORMAL_COMMENT = 3;
  int IN_MULTI_LINE_COMMENT = 4;
  int IN_CATEGORY_COMMENT = 5;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\f\"",
    "\"\\u001a\"",
    "<token of kind 5>",
    "\"\\n\"",
    "\"\\r\"",
    "\"\\r\\n\"",
    "\"//\"",
    "<token of kind 10>",
    "\"/*\"",
    "\"/*<\"",
    "<SINGLE_LINE_COMMENT>",
    "\"*/\"",
    "\"*/\"",
    "\"*/\"",
    "<token of kind 17>",
    "\"abstract\"",
    "\"boolean\"",
    "\"break\"",
    "\"byte\"",
    "\"case\"",
    "\"catch\"",
    "\"char\"",
    "\"class\"",
    "\"const\"",
    "\"continue\"",
    "\"default\"",
    "\"do\"",
    "\"double\"",
    "\"else\"",
    "\"extends\"",
    "\"false\"",
    "\"final\"",
    "\"finally\"",
    "\"float\"",
    "\"for\"",
    "\"goto\"",
    "\"if\"",
    "\"implements\"",
    "\"import\"",
    "\"instanceof\"",
    "\"int\"",
    "\"interface\"",
    "\"long\"",
    "\"native\"",
    "\"new\"",
    "\"null\"",
    "\"package\"",
    "\"private\"",
    "\"protected\"",
    "\"public\"",
    "\"return\"",
    "\"short\"",
    "\"static\"",
    "\"strictfp\"",
    "\"super\"",
    "\"switch\"",
    "\"synchronized\"",
    "\"this\"",
    "\"throw\"",
    "\"throws\"",
    "\"transient\"",
    "\"true\"",
    "\"try\"",
    "\"void\"",
    "\"volatile\"",
    "\"while\"",
    "<INTEGER_LITERAL>",
    "<DECIMAL_LITERAL>",
    "<HEX_LITERAL>",
    "<OCTAL_LITERAL>",
    "<FLOATING_POINT_LITERAL>",
    "<EXPONENT>",
    "<CHARACTER_LITERAL>",
    "<STRING_LITERAL>",
    "<IDENTIFIER>",
    "<LETTER>",
    "<DIGIT>",
    "\"(\"",
    "\")\"",
    "\"{\"",
    "\"}\"",
    "\"[\"",
    "\"]\"",
    "\";\"",
    "\",\"",
    "\".\"",
    "\"...\"",
    "\"=\"",
    "\">\"",
    "\"<\"",
    "\"!\"",
    "\"~\"",
    "\"?\"",
    "\":\"",
    "\"==\"",
    "\"<=\"",
    "\">=\"",
    "\"!=\"",
    "\"||\"",
    "\"&&\"",
    "\"++\"",
    "\"--\"",
    "\"+\"",
    "\"-\"",
    "\"*\"",
    "\"/\"",
    "\"&\"",
    "\"|\"",
    "\"^\"",
    "\"%\"",
    "\"<<\"",
    "\">>\"",
    "\">>>\"",
    "\"+=\"",
    "\"-=\"",
    "\"*=\"",
    "\"/=\"",
    "\"&=\"",
    "\"|=\"",
    "\"^=\"",
    "\"%=\"",
    "\"<<=\"",
    "\">>=\"",
    "\">>>=\"",
    "\"@\"",
  };

}
